"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var generateInterface = function (_a) {
    var name = _a.name, comment = _a.comment, properties = _a.properties, exportAsDefault = _a.exportAsDefault;
    var lines = [];
    if (comment) {
        lines.push('/**', " * " + comment, ' */');
    }
    var exportStr = exportAsDefault ? 'export default' : 'export';
    lines.push(exportStr + " interface " + name + " {");
    properties.forEach(function (property, index) {
        if (index > 0) {
            lines.push('');
        }
        if (property.commentLines.length === 1) {
            lines.push("  /** " + property.commentLines[0] + " */");
        }
        else if (property.commentLines.length > 1) {
            lines.push('  /**');
            property.commentLines.forEach(function (commentLine) {
                return lines.push("   * " + commentLine);
            });
            lines.push('   */');
        }
        lines.push("  " + property.name + (property.optional ? '?' : '') + ": " + property.typeName + ";");
    });
    lines.push('}');
    return lines;
};
exports.default = generateInterface;
