export default generateModelFile;
export type TableOrView = import('extract-pg-schema').TableOrView;
export type Type = import('extract-pg-schema').Type;
export type TableModel = import('./Model').TableModel;
export type ViewModel = import('./Model').ViewModel;
export type Nominators = import('./Config').Nominators;
export type TypeMap = import('./Config').TypeMap;
/**
 * @typedef { import('extract-pg-schema').TableOrView } TableOrView
 * @typedef { import('extract-pg-schema').Type } Type
 * @typedef { import('./Model').TableModel } TableModel
 * @typedef { import('./Model').ViewModel } ViewModel
 * @typedef { import('./Config').Nominators } Nominators
 * @typedef { import('./Config').TypeMap } TypeMap
 */
/**
 * @param {TableModel | ViewModel} model
 * @param {{ typeMap: TypeMap, userTypes: (string | any)[], schemaName: string, nominators: Nominators, externalTypesFolder?: string, schemaFolderMap: {[schemaName: string]: string}, makeIdType: (innerType: string, modelName: string) => string }} p1
 * @returns {string[]}
 */
declare function generateModelFile(model: TableModel | ViewModel, { typeMap, userTypes, schemaName, nominators, externalTypesFolder, schemaFolderMap, makeIdType, }: {
    typeMap: TypeMap;
    userTypes: (string | any)[];
    schemaName: string;
    nominators: Nominators;
    externalTypesFolder?: string;
    schemaFolderMap: {
        [schemaName: string]: string;
    };
    makeIdType: (innerType: string, modelName: string) => string;
}): string[];
