"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param {import('extract-pg-schema').EnumType} type
 * @param {(typeName: string) => string} nominator
 * @returns {string[]}
 */
function generateTypeFile(type, nominator) {
    var lines = [];
    var comment = type.comment;
    if (comment) {
        lines.push("/** " + comment + " */");
    }
    lines.push("type " + nominator(type.name) + " = " + type.values
        .map(function (v) { return "'" + v + "'"; })
        .join(' | ') + ";");
    lines.push("export default " + nominator(type.name) + ";");
    return lines;
}
exports.default = generateTypeFile;
