"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = __importDefault(require("chalk"));
var extract_pg_schema_1 = require("extract-pg-schema");
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var ramda_1 = require("ramda");
var rmfr_1 = __importDefault(require("rmfr"));
var Config_1 = require("./Config");
var defaultTypeMap_1 = __importDefault(require("./defaultTypeMap"));
var logger_1 = require("./logger");
var processSchema_1 = __importDefault(require("./processSchema"));
var labelAsGenerated = function (lines) { return __spreadArray([
    '// @generated',
    "// Automatically generated. Don't change this file manually.",
    ''
], lines, true); };
var addEmptyLineAtEnd = function (lines) { return __spreadArray(__spreadArray([], lines, true), [''], false); };
var defaultHooks = [labelAsGenerated, addEmptyLineAtEnd];
/**
 * @param {import('./Config').default} config
 */
var processDatabase = function (_a) { return __awaiter(void 0, void 0, void 0, function () {
    var typeMap, nominators, modelProcessChain, typeProcessChain, schemaFolderMap, _i, schemas_1, schemaConfig, schema;
    var connection = _a.connection, _b = _a.preDeleteModelFolder, preDeleteModelFolder = _b === void 0 ? false : _b, _c = _a.customTypeMap, customTypeMap = _c === void 0 ? {} : _c, _d = _a.modelHooks, modelHooks = _d === void 0 ? [] : _d, _e = _a.modelNominator, modelNominator = _e === void 0 ? Config_1.nameIdentity : _e, _f = _a.propertyNominator, propertyNominator = _f === void 0 ? function (propertyName) {
        return propertyName.indexOf(' ') !== -1 ? "'" + propertyName + "'" : propertyName;
    } : _f, _g = _a.initializerNominator, initializerNominator = _g === void 0 ? function (modelName) { return modelName + "Initializer"; } : _g, _h = _a.idNominator, idNominator = _h === void 0 ? function (modelName) { return modelName + "Id"; } : _h, _j = _a.makeIdType, makeIdType = _j === void 0 ? function (innerType, modelName) {
        return innerType + " & { \" __flavor\"?: '" + modelName + "' };";
    } : _j, _k = _a.typeHooks, typeHooks = _k === void 0 ? [] : _k, _l = _a.typeNominator, typeNominator = _l === void 0 ? Config_1.nameIdentity : _l, _m = _a.fileNominator, fileNominator = _m === void 0 ? ramda_1.identity : _m, _o = _a.resolveViews, resolveViews = _o === void 0 ? false : _o, schemas = _a.schemas, unknownProps = __rest(_a, ["connection", "preDeleteModelFolder", "customTypeMap", "modelHooks", "modelNominator", "propertyNominator", "initializerNominator", "idNominator", "makeIdType", "typeHooks", "typeNominator", "fileNominator", "resolveViews", "schemas"]);
    return __generator(this, function (_p) {
        switch (_p.label) {
            case 0:
                if (!(0, ramda_1.isEmpty)(unknownProps)) {
                    console.warn("Unknown configuration properties: " + Object.keys(unknownProps).join(', '));
                }
                typeMap = __assign(__assign({}, defaultTypeMap_1.default), customTypeMap);
                nominators = {
                    modelNominator: modelNominator,
                    propertyNominator: propertyNominator,
                    initializerNominator: initializerNominator,
                    idNominator: idNominator,
                    typeNominator: typeNominator,
                    fileNominator: fileNominator,
                };
                modelProcessChain = __spreadArray(__spreadArray([], defaultHooks, true), modelHooks, true);
                typeProcessChain = __spreadArray(__spreadArray([], defaultHooks, true), typeHooks, true);
                logger_1.logger.log("Connecting to " + chalk_1.default.greenBright(connection.database) + " on " + connection.host);
                schemaFolderMap = (0, ramda_1.map)(function (s) { return path_1.default.resolve(s.modelFolder); }, (0, ramda_1.indexBy)(function (s) { return s.name; }, schemas));
                _i = 0, schemas_1 = schemas;
                _p.label = 1;
            case 1:
                if (!(_i < schemas_1.length)) return [3 /*break*/, 7];
                schemaConfig = schemas_1[_i];
                if (!preDeleteModelFolder) return [3 /*break*/, 3];
                logger_1.logger.log(" - Clearing old files in " + schemaConfig.modelFolder);
                return [4 /*yield*/, (0, rmfr_1.default)(schemaConfig.modelFolder, { glob: true })];
            case 2:
                _p.sent();
                _p.label = 3;
            case 3:
                if (!fs_1.default.existsSync(schemaConfig.modelFolder)) {
                    fs_1.default.mkdirSync(schemaConfig.modelFolder);
                }
                return [4 /*yield*/, (0, extract_pg_schema_1.extractSchema)(schemaConfig.name, connection, schemaConfig.resolveViews !== undefined
                        ? schemaConfig.resolveViews
                        : resolveViews)];
            case 4:
                schema = _p.sent();
                return [4 /*yield*/, (0, processSchema_1.default)(schemaConfig, schema, typeMap, nominators, modelProcessChain, typeProcessChain, schemaFolderMap, makeIdType)];
            case 5:
                _p.sent();
                _p.label = 6;
            case 6:
                _i++;
                return [3 /*break*/, 1];
            case 7: return [2 /*return*/];
        }
    });
}); };
exports.default = processDatabase;
