export default processSchema;
export type TableModel = import('./Model').TableModel;
export type ViewModel = import('./Model').ViewModel;
/**
 * @param {import('./Config').SchemaConfig} schemaConfig
 * @param {import('extract-pg-schema').Schema} schema
 * @param {import('./Config').TypeMap} typeMap
 * @param {import('./Config').Nominators} nominators
 * @param {(import("./Config").Hook<import('./Model').Model>)[]} modelProcessChain
 * @param {(import("./Config").Hook<import("extract-pg-schema").Type>)[]} typeProcessChain
 * @param {{[schameName: string]: string}} schemaFolderMap
 */
declare function processSchema(schemaConfig: import('./Config').SchemaConfig, schema: import('extract-pg-schema').Schema, typeMap: import('./Config').TypeMap, nominators: import('./Config').Nominators, modelProcessChain: (import("./Config").Hook<import('./Model').Model>)[], typeProcessChain: (import("./Config").Hook<import("extract-pg-schema").Type>)[], schemaFolderMap: {
    [schameName: string]: string;
}, makeIdType: any): Promise<void>;
