"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var ramda_1 = require("ramda");
var generateCompositeTypeFile_1 = __importDefault(require("./generateCompositeTypeFile"));
var generateIndexFile_1 = __importDefault(require("./generateIndexFile"));
var generateModelFile_1 = __importDefault(require("./generateModelFile"));
var generateTypeFile_1 = __importDefault(require("./generateTypeFile"));
var getSupportedTypes_1 = __importDefault(require("./getSupportedTypes"));
var Matcher_1 = require("./Matcher");
var writeFile_1 = __importDefault(require("./writeFile"));
/**
 * @typedef { import('./Model').TableModel } TableModel
 * @typedef { import('./Model').ViewModel } ViewModel
 */
var applyHooks = function (chain, src, lines) {
    var boundChain = chain.map(function (f) { return function (l) { return f(l, src); }; });
    // @ts-ignore
    return ramda_1.pipe.apply(void 0, boundChain)(lines);
};
/**
 * @param {import('./Config').SchemaConfig} schemaConfig
 * @param {import('extract-pg-schema').Schema} schema
 * @param {import('./Config').TypeMap} typeMap
 * @param {import('./Config').Nominators} nominators
 * @param {(import("./Config").Hook<import('./Model').Model>)[]} modelProcessChain
 * @param {(import("./Config").Hook<import("extract-pg-schema").Type>)[]} typeProcessChain
 * @param {{[schameName: string]: string}} schemaFolderMap
 */
var processSchema = function (schemaConfig, schema, typeMap, nominators, modelProcessChain, typeProcessChain, schemaFolderMap, makeIdType) { return __awaiter(void 0, void 0, void 0, function () {
    var tables, views, types, _a, compositeTypes, enumTypes, models, rejectIgnored, includedModels, userTypes, tableOrViewTypes, indexFileLines, wetIndexFileLines;
    return __generator(this, function (_b) {
        tables = schema.tables, views = schema.views, types = schema.types;
        _a = (0, getSupportedTypes_1.default)(types), compositeTypes = _a.compositeTypes, enumTypes = _a.enumTypes;
        enumTypes.forEach(function (t) {
            var typeFileLines = (0, generateTypeFile_1.default)(t, nominators.typeNominator);
            var wetTypeFileLines = applyHooks(typeProcessChain, t, typeFileLines);
            var givenName = nominators.typeNominator(t.name);
            var filename = nominators.fileNominator(givenName, t.name) + ".ts";
            (0, writeFile_1.default)({
                fullPath: path_1.default.join(schemaConfig.modelFolder, filename),
                lines: wetTypeFileLines,
            });
        });
        models = __spreadArray(__spreadArray([], tables.map(function (t) { /** @type {TableModel} */ return (__assign(__assign({}, t), { type: 'table' })); }), true), views.map(function (t) { /** @type {ViewModel} */ return (__assign(__assign({}, t), { type: 'view' })); }), true);
        rejectIgnored = (0, ramda_1.reject)(function (m) {
            return (schemaConfig.ignore || []).some(function (matcher) { return (0, Matcher_1.isMatch)(m.name, matcher); });
        });
        includedModels = rejectIgnored(models);
        userTypes = (0, ramda_1.pluck)('name', types);
        tableOrViewTypes = (0, ramda_1.pluck)('name', includedModels);
        compositeTypes.forEach(function (m) {
            var modelFileLines = (0, generateCompositeTypeFile_1.default)(m, {
                typeMap: typeMap,
                userTypes: userTypes,
                tableOrViewTypes: tableOrViewTypes,
                nominators: nominators,
                schemaName: schemaConfig.name,
                externalTypesFolder: schemaConfig.externalTypesFolder,
                schemaFolderMap: schemaFolderMap,
            });
            var wetModelFileLines = applyHooks(modelProcessChain, m, modelFileLines);
            var filename = nominators.fileNominator(nominators.modelNominator(m.name), m.name) + ".ts";
            (0, writeFile_1.default)({
                fullPath: path_1.default.join(schemaConfig.modelFolder, filename),
                lines: wetModelFileLines,
            });
        });
        includedModels.forEach(function (m) {
            var modelFileLines = (0, generateModelFile_1.default)(m, {
                typeMap: typeMap,
                userTypes: userTypes,
                nominators: nominators,
                schemaName: schemaConfig.name,
                externalTypesFolder: schemaConfig.externalTypesFolder,
                schemaFolderMap: schemaFolderMap,
                makeIdType: makeIdType,
            });
            var wetModelFileLines = applyHooks(modelProcessChain, m, modelFileLines);
            var filename = nominators.fileNominator(nominators.modelNominator(m.name), m.name) + ".ts";
            (0, writeFile_1.default)({
                fullPath: path_1.default.join(schemaConfig.modelFolder, filename),
                lines: wetModelFileLines,
            });
        });
        indexFileLines = (0, generateIndexFile_1.default)(includedModels, userTypes, nominators);
        wetIndexFileLines = applyHooks(modelProcessChain, {}, indexFileLines);
        (0, writeFile_1.default)({
            fullPath: path_1.default.join(schemaConfig.modelFolder, 'index.ts'),
            lines: wetIndexFileLines,
        });
        return [2 /*return*/];
    });
}); };
exports.default = processSchema;
